from ConfigParser import ConfigParser, NoOptionError


class NoSettingsError:
    pass


def create_blocks(form):
    cp = ConfigParser()
    
    bx = {}
    
    try:
        cp.read("content/settings")
    except IOError:
        raise NoSettingsError

    page = form.getfirst("p")
    if not page:
        page = default(cp)
    page = page.replace("\\", "").replace(r"/", "")

    bx["sitename"] = cp.get("site", "sitename")
    bx["title"] = title(cp, page)
    bx["navigation"] = navigation(cp, page)
    
    try:
        bx["body"] = open("pages/" + page).read()
    except IOError:
        bx["body"] = "<p>404, no such page.</p>"
    
    return bx
    
    
def navigation(cp, active_page):
    s = "<ul>\n"
    
    for page in cp.get("site", "navbar").split():
        ins = ""
        if page == active_page:
            ins = 'class="active"'
        
        link = '?p=%s' % page
        if page == default(cp):
            link = ""
        
        s += ('<li %s><a href="./%s">%s</a></li>'
            % (ins, link, title(cp, page)))

        
    return s + "\n</ul>\n"


def title(cp, page):
    try:
        return cp.get("pages", page)
    except NoOptionError:
        return page


def default(cp):
    return cp.get("site", "default")
