from sys import stdout


class ParsingError(Exception):
    pass


def out(text):
    for c in text:
        try:
            stdout.write(c)
        except UnicodeEncodeError:
            stdout.write("?")
            

def parse(scheme, blocks):
    state = 0
    call = ""
    
    for ch in scheme:
        if state == 0:
            if ch == "<":
                state = 1
                call = ""
            else:
                out(ch)
        elif state == 1:
            if ch == "#":
                state = 2
            else:
                state = 0
                out("<" + ch)
        elif state == 2:
            if ch == "#":
                state = 3
                try:
                    stdout.write(blocks[call])
                except KeyError:
                    stdout.write("[#undefined block %s#]" % call)
                
            else:
                call += ch
        elif state == 3:
            if ch == ">":
                state = 0
            else:
                raise ParsingError
        else:
           raise ParsingError
